zoukankan      html  css  js  c++  java
  • Unique Paths II leetcode java

    题目

    Follow up for "Unique Paths":

    Now consider if some obstacles are added to the grids. How many unique paths would there be?

    An obstacle and empty space is marked as 1 and 0 respectively in the grid.

    For example,

    There is one obstacle in the middle of a 3x3 grid as illustrated below.

    [
      [0,0,0],
      [0,1,0],
      [0,0,0]
    ]
    

    The total number of unique paths is 2.

    Note: m and n will be at most 100.

    题解:

    这道题大体想法跟Unique Path是一样的。

    只是要单独考虑下障碍物对整个棋盘的影响。

    先看看初始条件会不会受到障碍物的影响。

    假设整个棋盘只有一行,那么在第i个位置上设置一个障碍物后,说明位置i到最后一个格子这些路都没法走了。

    如果整个棋盘只有一列,那么第i位置上的障碍物,也会影响从第i位置往后的路。

    所以说明,在初始条件时,如果一旦遇到障碍物,障碍物后面所有格子的走法都是0。

    再看求解过程,当然按照上一题的分析dp[i][j] = dp[i-1][j] + dp[i][j-1] 的递推式依然成立(机器人只能向下或者向右走嘛)。但是,一旦碰到了障碍物,那么这时的到这里的走法应该设为0,因为机器人只能向下走或者向右走,所以到这个点就无法通过。

    处理完障碍物的特殊问题,依照unique paths改一下代码就好。

    代码如下:

     1    public int uniquePathsWithObstacles(int[][] obstacleGrid) {  
     2         int m = obstacleGrid.length;  
     3         int n = obstacleGrid[0].length;  
     4         
     5         if(m==0||n == 0)  
     6             return 0; 
     7         
     8         if(obstacleGrid[0][0] == 1 || obstacleGrid[m-1][n-1] == 1)  
     9             return 0; 
    10             
    11         int[][] dp = new int[m][n]; 
    12         
    13         dp[0][0] = 1;  
    14         for(int i = 1; i < n; i++){  
    15             if(obstacleGrid[0][i] == 1)  
    16                 dp[0][i] = 0;  
    17             else 
    18                 dp[0][i] = dp[0][i-1];  
    19         }  
    20         
    21         for(int i = 1; i < m; i++){  
    22             if(obstacleGrid[i][0] == 1)  
    23                 dp[i][0] = 0;  
    24             else 
    25                 dp[i][0] = dp[i-1][0];  
    26         }  
    27         
    28         for(int i = 1; i < m; i++){  
    29             for(int j = 1; j < n; j++){  
    30                 if(obstacleGrid[i][j] == 1)  
    31                     dp[i][j] = 0;  
    32                 else  
    33                     dp[i][j] = dp[i][j-1] + dp[i-1][j];  
    34             }  
    35         }  
    36         return dp[m-1][n-1];  
    37     } 

  • 相关阅读:
    Performance Tuning of Spring/Hibernate Applications---reference
    5 Common Interview Mistakes that Could Cost You Your Dream Job (and How to Avoid Them)--ref
    linux 清空文件内容命令
    linux shell read command-Getting User Input Via Keyboard--ref
    EasyUI禁用控制方法常采用
    HDU ACM 1088 Write a simple HTML Browser
    opengl微发展理解
    atitit.(设计模式1)--—职责链(chain of responsibility)最佳实践O7 转换日期
    Jedis连接
    使用WindowManager添加您自己的自定义视图
  • 原文地址:https://www.cnblogs.com/springfor/p/3886644.html
Copyright © 2011-2022 走看看